#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef enum {S = 0, S1 = 1, A = 2, A1 = 3, B = 4, B1 = 5, C = 6, CH = 7, 
	ABCS1 = 8, AA1BC = 9, AA1BCCH = 10, AB1CH = 11, ACH = 12, AB1 = 13} stav_t;

typedef enum {CISLO = 0, UNARNI_OPERATOR = 1, BINARNI_OPERATOR = 2, TECKA = 3} pismeno_t;

stav_t prechod[14][4] = 
	{{ABCS1, A, CH, CH},		// S - >
	 {CH, CH, CH, A},		// S1
	 {AA1BC, CH, CH, CH},		// A
	 {CH, CH, CH, A},		// A1
	 {CH, CH, AB1, CH},		// B
	 {CH, A, CH, CH},		// B1
	 {CH, CH, CH, CH},		// C
	 {CH, CH, CH, CH},		// CH
	 {AA1BCCH, CH, AB1CH, ACH},	// ABCS1
	 {AA1BCCH, CH, AB1CH, ACH},	// AA1BC
	 {AA1BCCH, CH, AB1CH, ACH},	// AA1BCCH
	 {AA1BCCH, ACH, CH, CH},	// AB1CH
	 {AA1BCCH, CH, CH, CH},		// ACH
	 {AA1BCCH, ACH, CH, CH}};	// AB1

char* nazvy_stavu[14] = {"S", "S1", "A", "A1", "B", "B1", "C", "CH", "A,B,C,S1", 
	"A,A1,B,C", "A,A1,B,C,CH", "A,B1,CH", "A,CH", "A,B1"};

pismeno_t zjednodus(char c){
	if ((c >= '0') && (c <= '9')) return CISLO;
	if (c == '_') return UNARNI_OPERATOR;
	if ((c == '*') || (c == '/') || (c == '+') || (c == '-')) return BINARNI_OPERATOR;
	if (c == '.') return TECKA;
	else {
		printf("%c neni v abecede\n");
		exit(EXIT_FAILURE);
	}
}

int main(int argc, char** argv){
	char vstup[256];
	stav_t stav;
	
	stav = S;
	printf("Zadejte prosim vstup - vstupni abeceda: {0..9,/,*,+,-,.,_}\n");
	printf("_ - reprezentuje unarni minus (napr. -2)\n");
	fflush(stdout);
	fgets(vstup, 256, stdin);
	for (int i = 0; i < strlen(vstup) - 1; i++) {
		printf("%s -> ", nazvy_stavu[stav]);
		stav = prechod[stav][zjednodus(vstup[i])];
	}
	printf("%s\n",nazvy_stavu[stav]);
	if ((stav == C) || (stav == AA1BC) || (stav == AA1BCCH) || (stav == ABCS1))
		printf("Retezec rozpoznan\n");
	else 
		printf("Retezec nerozpoznan\n");
	return 0;
}

